<template>
  <div ref="linkWrapper" class="flex items-center gap-4 xs:flex-col relative">
    <UiButton
      style="min-width: 0; min-height: 64px"
      color-type="secondary"
      button-height="md"
      class="justify-between gap-3 px-5 flex-1 xs:w-full rounded-24"
      :class="{ 'nodekey__key-button_animated': loading }"
      @click="copyText"
    >
      <img src="@/assets/images/views/endpoint/link.svg" />
      <transition name="fade">
        <div v-if="nodeInfo.prefix" style="min-width: 0" class="flex-1 text-white">
          <p class="nodelink__link-text whitespace-nowrap overflow-hidden overflow-ellipsis">{{ endpointLink }}</p>
        </div>
      </transition>
      <p v-if="isValueCopied">{{ $t('endpoint.copied') }}</p>
      <img v-else src="@/assets/images/views/endpoint/copy.svg" />
    </UiButton>
    <a href="https://flashnodes.gitbook.io/flashnodes/" target="_blank" rel="nofollow" class="xs:w-full">
      <UiButton color-type="outline" button-height="md" class="gap-3 xs:w-full rounded-24 px-5">
        <img src="@/assets/images/views/endpoint/docs.svg" />
        <p>{{ $t('endpoint.docs') }}</p>
      </UiButton>
    </a>
  </div>
</template>

<script>
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'NodeLink',

  components: { UiButton },

  props: {
    nodeInfo: {
      type: Object,
      default: () => ({}),
    },

    loading: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      copyTimeout: null,
      isValueCopied: false,
    };
  },

  computed: {
    endpointLink() {
      if (!this.nodeInfo.api_key) return '';
      return `https://${this.nodeInfo.prefix}.flashnodes.io/v1/${this.nodeInfo.cryptocurrency_symbol.toLowerCase()}/${
        this.nodeInfo.network
      }/${this.nodeInfo.mode}/${this.nodeInfo.api_key}/`;
    },
  },

  methods: {
    copyTextIos() {
      const wrapper = this.$refs.linkWrapper;
      const textArea = document.createElement('textArea');
      textArea.style.position = 'absolute';
      textArea.style.opacity = '0';
      textArea.setAttribute('readonly', true);
      textArea.value = this.endpointLink;
      wrapper.appendChild(textArea);

      const range = document.createRange();
      range.selectNodeContents(textArea);
      const selection = window.getSelection();
      selection.removeAllRanges();
      selection.addRange(range);
      textArea.setSelectionRange(0, 999999);

      document.execCommand('copy');
      wrapper.removeChild(textArea);
    },

    async copyTextPc() {
      await navigator.clipboard.writeText(this.endpointLink);
    },

    async copyText() {
      const isIOS = navigator.userAgent.match(/ipad|iphone/i);
      try {
        if (isIOS) this.copyTextIos();
        else await this.copyTextPc();
        if (this.copyTimeout) clearTimeout(this.copyTimeout);
        this.isValueCopied = true;
        this.copyTimeout = setTimeout(() => {
          this.isValueCopied = false;
        }, 3000);
      } catch (err) {
        console.error('[CopyText Error]');
        console.error(err);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.nodekey {
  &__key-button {
    &_animated {
      animation-duration: 2s;
      animation-fill-mode: forwards;
      animation-iteration-count: infinite;
      animation-name: loading-animation;
      animation-timing-function: linear;
      background-color: #f6f7f8;
      background: linear-gradient(to right, #17283e 8%, #111e2f 50%, #17283e 100%);
      background-size: 500px;
    }
  }
}

@keyframes loading-animation {
  0% {
    background-position: -500px 0;
  }
  100% {
    background-position: 500px 0;
  }
}
</style>
